#ifndef _STM32_H
#define _STM32_H 1

#if defined STM32F0XX
  #include <stm32f0xx.h>
  #define __CMSIS_VERSION_MAIN            __CM0_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM0_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F0xx"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F0XX_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F0XX_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F0XX_STDPERIPH_VERSION_SUB2
#elif defined STM32F10X_LD || defined STM32F10X_LD_VL || \
      defined STM32F10X_MD || defined STM32F10X_MD_VL || \
      defined STM32F10X_HD || defined STM32F10X_HD_VL || \
      defined STM32F10X_XL || defined STM32F10X_CL
  #include <stm32f10x.h>
  #define __CMSIS_VERSION_MAIN            __CM3_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM3_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F10x"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F10X_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F10X_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F10X_STDPERIPH_VERSION_SUB2
#elif defined STM32F2XX
  #include <stm32f2xx.h>
  #define __CMSIS_VERSION_MAIN            __CM3_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM3_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F2xx"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F2XX_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F2XX_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F2XX_STDPERIPH_VERSION_SUB2
#elif defined STM32F30X
  #include <stm32f30x.h>
  #define __CMSIS_VERSION_MAIN            __CM4_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM4_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F30x"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F30X_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F30X_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F30X_STDPERIPH_VERSION_SUB2
#elif defined STM32F37X
  #include <stm32f37x.h>
  #define __CMSIS_VERSION_MAIN            __CM4_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM4_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F37x"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F37X_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F37X_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F37X_STDPERIPH_VERSION_SUB2
#elif defined STM32F4XX
  #include <stm32f4xx.h>
  #define __CMSIS_VERSION_MAIN            __CM4_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM4_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32F4xx"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32F4XX_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32F4XX_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32F4XX_STDPERIPH_VERSION_SUB2
#elif defined STM32L1XX_MD || defined STM32L1XX_MDP || \
      defined STM32L1XX_HD
  #include <stm32l1xx.h>
  #define __CMSIS_VERSION_MAIN            __CM3_CMSIS_VERSION_MAIN
  #define __CMSIS_VERSION_SUB             __CM3_CMSIS_VERSION_SUB
  #define __STM32_STDPERIPH_LIBRARY       "STM32L1xx"
  #define __STM32_STDPERIPH_VERSION_MAIN  __STM32L1XX_STDPERIPH_VERSION_MAIN
  #define __STM32_STDPERIPH_VERSION_SUB1  __STM32L1XX_STDPERIPH_VERSION_SUB1
  #define __STM32_STDPERIPH_VERSION_SUB2  __STM32L1XX_STDPERIPH_VERSION_SUB2
#else
  #error STM32 device subfamily is unknown or undefined.
#endif

#endif
